;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Format File
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
pushx MACRO parameters:VARARG
	LOCAL param, reversed, c
	param TEXTEQU <>
	reversed TEXTEQU <>
	forc c, <&parameters>
		IFIDN <c>, < >
			reversed CATSTR param, < >, reversed
			param TEXTEQU <>
		ELSE
			param CATSTR param, <c>
		ENDIF
	endm
	reversed CATSTR param, < >, reversed
	param TEXTEQU <>
%	forc c, <&reversed>
		IFIDN <c>, < >
			push	param
			param TEXTEQU <>
		ENDIF
		param CATSTR param, <c>
	endm
ENDM
popx MACRO parameters:VARARG
	LOCAL param, c
	param TEXTEQU <>
	forc c, <&parameters>
		IFIDN <c>, < >
			pop	param
			param TEXTEQU <>
		ENDIF
		param CATSTR param, <c>
	endm
	pop	param
ENDM
;##########################################################################
;##########################################################################
	CurDate		TEXTEQU	<">, @Date, <">
	CurTime		TEXTEQU	<">, @Time, <">
	CurFileName	TEXTEQU	<">, @FileCur, <">
	CurVersion	TEXTEQU	<">, @Version, <">
;##########################################################################
ProcessCmdLine	PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szMsgAbout	db		"Format File", 13, 10
			db		"Built on ", CurDate, " ", CurTime, " with MASM ", CurVersion, 13, 10
			db		"Version 1.01", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"     http://comrade64.cjb.net/", 13, 10
			db		"     http://comrade.ownz.com/", 13, 10
			db		"     http://comrade.win32asm.com/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 13, 10
			db		"Usage: fmtfile.exe /b <inputfile> <outputfile> <#1-9>", 13, 10
	dwMsgAboutLen	equ		$ - szMsgAbout
	szMsgDone	db		"Done!", 13, 10
	szMsgError	db		"Error!", 13, 10
	szBlank		db		0
	szErrorThread	db		13, 10, "Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 13, 10, 0
	szErrorFinal	db		13, 10, "Error at %08Xh", 13, 10, "Quitting...", 13, 10, 0
;##########################################################################
.data
;##########################################################################
.data?
	hStdOut		dd		?
	hFileIn		dd		?
	dwFileInSize	dd		?
	hFileInMap	dd		?
	dwFileIn	dd		?
	hFileOut	dd		?
	hMemoryOut	dd		?
	dwFileOut	dd		?
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)

	data_start	equ		$
	argc		dd		?
	argv		dd		16 dup (?)
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov	[hStdOut], eax
	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	; install the SEH-frame
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	; zero uninitialized data
	pushx	ebx esi edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	call	ProcessCmdLine
	cmp	[argc], 4
	jae	@@argok
	invoke	WriteFile, [hStdOut], ADDR szMsgAbout, dwMsgAboutLen, esp, 0
	xor	eax, eax
	jmp	@@quit
@@argok:mov	eax, [argv+04h]
	xor	ebx, ebx
	cmp	word ptr [eax], "B/"	; /B
	je	@@hb
	cmp	word ptr [eax], "b/"	; /b
	jne	@@file
@@hb:	add	ebx, 4
@@file:	invoke	CreateFile, [argv+04h+ebx], GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
	cmp	eax, INVALID_HANDLE_VALUE
	mov	[hFileIn], eax
	je	@@err
	invoke	CreateFileMapping, eax, 0, PAGE_READONLY, 0, 0, 0
	test	eax, eax
	mov	[hFileInMap], eax
	jz	@@err
	invoke	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
	test	eax, eax
	mov	[dwFileIn], eax
	jz	@@err
	invoke	CreateFile, [argv+08h+ebx], GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0
	mov	[hFileOut], eax
	inc	eax
	jz	@@err
	invoke	GetFileSize, [hFileIn], 0
	cmp	eax, -1
	mov	[dwFileInSize], eax
	je	@@err
	add	eax, 1000h
	invoke	GlobalAlloc, GMEM_MOVEABLE, eax
	test	eax, eax
	mov	[hMemoryOut], eax
	jz	@@err
	invoke	GlobalLock, eax
	test	eax, eax
	mov	[dwFileOut], eax
	jz	@@err
	mov	esi, [dwFileIn]
	mov	edi, eax
	mov	ecx, [dwFileInSize]
@@next:	cmp	ecx, 1
	jbe	@@char
	cmp	byte ptr [esi], "%"	; format
	jne	@@char
	movzx	eax, byte ptr [esi+01h]
	sub	eax, "0"
	jle	@@char
	cmp	eax, 9
	jg	@@char
	mov	edx, [argv+0Ch-04h+ebx][eax*4]
	xor	eax, eax
	test	edx, edx
	jnz	@@docp
	test	ebx, ebx
	jz	@@char
	mov	edx, OFFSET szBlank
@@docp:	push	esi
	mov	esi, edx
@@copy:	lodsb
	test	eax, eax
	stosb
	jnz	@@copy
	pop	esi
	dec	edi
	add	esi, 2
	sub	ecx, 2
	jle	@@done
	jg	@@next
@@char:	movsb
@@chkl:	loop	@@next
@@done:	sub	edi, [dwFileOut]
	invoke	WriteFile, [hFileOut], [dwFileOut], edi, esp, ecx
	invoke	WriteFile, [hStdOut], ADDR szMsgDone, sizeof szMsgDone, esp, 0
	xor	eax, eax
	inc	eax
	jmp	@@quit
@@err:	invoke	WriteFile, [hStdOut], ADDR szMsgError, sizeof szMsgError, esp, 0
	xor	eax, eax
@@quit:	popx	ebx esi edi
@@safe:	pop	FS:[0]
	mov	[esp], eax
	invoke	CloseHandle, [hFileOut]
	invoke	UnmapViewOfFile, [dwFileIn]
	invoke	CloseHandle, [hFileInMap]
	invoke	CloseHandle, [hFileIn]
	jmp	ExitProcess
;##########################################################################
ProcessCmdLine proc
	pushx	ebx esi edi
	call	GetCommandLine
	mov	esi, eax
	mov	edi, OFFSET argv
	xor	ecx, ecx
	xor	ebx, ebx
	xor	edx, edx
@@cmss:	mov	eax, esi
	mov	dl, 20h
	cmp	byte ptr [esi], 22h
	sete	cl
	lea	edx, [edx+ecx*2]
	add	eax, ecx
	stosd
@@cm00:	inc	esi
	cmp	byte ptr [esi], 0
	je	@@cm01
	cmp	byte ptr [esi], dl
	jne	@@cm00
	mov	byte ptr [esi], 0
	add	esi, ecx
	inc	esi
	cmp	byte ptr [esi], 0
	je	@@cm01
	inc	[argc]
	jmp	@@cmss
@@cm01:	popx	ebx esi edi
	inc	[argc]
	ret
ProcessCmdLine endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start